﻿--[[
	Navigator

]]--

-- hard-coded configs

local ClearWhenClosed = true

-- Basic localizations
-- Init
function Navigator_OnLoad(self)
	-- GUI
	if not NavigatorDB then NavigatorDB = {} end -- fresh DB
	local x, y, z,cx,ccx,cy,ccy, w, h = NavigatorDB.X, NavigatorDB.Y, NavigatorDB.Width, NavigatorDB.Height, p
	if not x or not y or not w or not h then
		Navigator_SaveAnchors()
	else
		self:ClearAllPoints()
		self:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", x, y)
		self:SetWidth(w)
		self:SetHeight(h)
	end
	if not NavigatorWorldFrame then
        	NavigatorWorldFrame = CreateFrame("Frame", nil, WorldMapFrame)
        	NavigatorWorldFrame.Deg = NavigatorWorldFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
	        NavigatorWorldFrame.Deg:SetPoint("RIGHT", WorldMapPositioningGuide, "BOTTOM", -25, 15)
		NavigatorWorldFrame:SetScript("OnUpdate", Navigator_UpdateCurserPosition)
		NavigatorWorldFrame.Deg:SetFormattedText("XX Heading")
		NavigatorWorldFrame.Deg:Show()
        end
	
	-- slash command
	SLASH_Navigator1 = "/Navigator";
	SLASH_Navigator2 = "/Nav";
	SlashCmdList["Navigator"] = function (msg)
		if msg == "Show" or msg == "show" then
			Navigator_ShowWindow()
		end
	end
end

-- Event handler

function Navigator_UpdatePosition()
	z=deg(GetPlayerFacing("player"))
	NavigatorFrameTitle:SetText(string.format("%d Head",359-z))
	x,y=GetPlayerMapPosition("player")
        p=deg(GetUnitPitch("player"))
	NavigatorFrameStatusText:SetText(string.format("%.1f X %.1f  %d Pitch",x*100,y*100,p))

end
-- line 43
function Navigator_UpdateCurserPosition()
	x,y=GetPlayerMapPosition("player")
	cx,cy=GetCursorPosition()
        ccx = (cx/WorldMapDetailFrame:GetEffectiveScale() - WorldMapDetailFrame:GetLeft()) / WorldMapDetailFrame:GetWidth()
        ccy = (WorldMapDetailFrame:GetTop() - cy/WorldMapDetailFrame:GetEffectiveScale()) / WorldMapDetailFrame:GetHeight()
        if ccx < 0 or ccx > 1 or ccy < 0 or ccy > 1 then
            	ccx=0
		ccy=0
		z=0
        else
		if y - ccy > 0 or y - ccy < 0 then
			z=atan((x-ccx)/((y-ccy)*(WorldMapDetailFrame:GetHeight()/WorldMapDetailFrame:GetWidth())))
		end
		if x - ccx < 0 then
			if y - ccy > 0 then
				z=-z
			end
			if y - ccy == 0 then
				z=90
			end
			if y - ccy < 0 then
				z=180-z
			end
		end
		if x - ccx > 0 then
			if y - ccy > 0 then
				z=360-z
			end
			if y - ccy == 0 then
				z=270
			end
			if y - ccy < 0 then
				z=180-z
			end
		end
		if x - ccx == 0 then
			z=180
			if y - ccy > 0 then
				z=0
			end
		end
	end

	if x == 0 or y == 0 or ccx == 0 or ccy == 0 then 
			NavigatorWorldFrame.Deg:SetFormattedText("No Heading,    Location %.1f X %.1f",ccx*100,ccy*100)
			NavigatorFrameTitle:SetText(string.format("No Heading"))
	else
			NavigatorWorldFrame.Deg:SetFormattedText("%d Heading,    Location %.1f X %.1f",z,ccx*100,ccy*100)
			NavigatorFrameTitle:SetText(string.format("%d Heading",z))
	end
	NavigatorFrameStatusText:SetText(string.format("%.1f X %.1f",ccx*100,ccy*100))
end
-- line 100?
hooksecurefunc("WorldMap_ToggleSizeUp", function()
        NavigatorWorldFrame:Show()
end)

hooksecurefunc("WorldMap_ToggleSizeDown", function()
       	NavigatorWorldFrame:Hide()
end)

-- GUI
function Navigator_SaveAnchors()
	NavigatorDB.X = NavigatorFrame:GetLeft()
	NavigatorDB.Y = NavigatorFrame:GetTop()
	NavigatorDB.Width = NavigatorFrame:GetWidth()
	NavigatorDB.Height = NavigatorFrame:GetHeight()
end

function Navigator_ShowWindow()
	NavigatorFrame:Show()
	Navigator_UpdatePosition()
end


-- BINDING_HEADER_NAVIGATOR = "Navigator"
-- BINDING_NAME_NAVIGATOR_UPDATE = L["Update Navigator Data"]

